;==============================================================================

; file: "_kernel#.scm"

; Copyright (C) 1994-2002 by Marc Feeley, All Rights Reserved.

;==============================================================================

; Representation of exceptions.

(define-structure-type-macros
  heap-overflow-exception)

(define-structure-type-macros
  stack-overflow-exception)

(define-structure-type-macros
  nonprocedure-operator-exception
  operator
  arguments
  code
  rte)

(define-structure-type-macros
  wrong-number-of-arguments-exception
  procedure
  arguments)

(define-structure-type-macros
  keyword-expected-exception
  procedure
  arguments)

(define-structure-type-macros
  unknown-keyword-argument-exception
  procedure
  arguments)

(define-structure-type-macros
  c-lambda-conversion-exception
  procedure
  arguments
  code
  message)

(define-structure-type-macros
  c-define-conversion-exception
  procedure
  arguments
  code
  message)

(define-structure-type-macros
  multiple-c-return-exception)

(define-structure-type-macros
  number-of-arguments-limit-exception
  procedure
  arguments)

(define-structure-type-macros
  type-exception
  procedure
  arguments
  arg-num
  type-id)

(define-structure-type-macros
  os-exception
  procedure
  arguments
  message
  code)

;------------------------------------------------------------------------------

(##define-macro (macro-debug-settings-level-mask)      15)
(##define-macro (macro-debug-settings-level-shift)     0)
(##define-macro (macro-debug-settings-signal-uncaught) 16)
(##define-macro (macro-debug-settings-single-step)     32)

(##define-macro (macro-debug-settings-level settings)
  `(##fixnum.logical-shift-right
    (##fixnum.bitwise-and ,settings (macro-debug-settings-level-mask))
    (macro-debug-settings-level-shift)))

;==============================================================================
